
class Advanced {
    def useClosure(closure) {
        [1,2,3].each(closure)
    }

    def searchList(closure) {
        return (1..10).findAll(closure)
    }
}


<?php

groovy_import("advanced.groovy");
$advanced = new Advanced();

class Foo {
    var $index = 0;
    function callback($value) {
        echo "[".$this->index++."] ".$value."\n";
    }
}

$foo = new Foo();

$closure = groovy_create_closure(array($foo, "callback"));
var_dump($closure);
$advanced->useClosure($closure);

function check_value($value) {
    echo "Checking [".$value."]\n";
    return (($value % 2) != 0);
}

$closure = groovy_create_closure("check_value");
var_dump($closure);
$results = $advanced->searchList($closure);

foreach ($results as $value) {
    echo $value."\n";
}

?>

